require '_h2ph_pre.ph';

unless(defined(&_INTERMEZZO_LIB_H)) {
    eval 'sub _INTERMEZZO_LIB_H () {1;}' unless defined(&_INTERMEZZO_LIB_H);
    if(defined(&__KERNEL__)) {
	require 'linux/types.ph';
    } else {
	require 'string.ph';
	require 'sys/types.ph';
    }
    undef(&MIN) if defined(&MIN);
    eval 'sub MIN {
        local($a,$b) = @_;
	    eval q(((($a)<($b)) ? ($a): ($b)));
    }' unless defined(&MIN);
    undef(&MAX) if defined(&MAX);
    eval 'sub MAX {
        local($a,$b) = @_;
	    eval q(((($a)>($b)) ? ($a): ($b)));
    }' unless defined(&MAX);
    eval 'sub MKSTR {
        local($ptr) = @_;
	    eval q((($ptr))? ($ptr) : \\"\\");
    }' unless defined(&MKSTR);
    if(defined(&__KERNEL__)) {
	eval 'sub NTOH__u32 {
	    local($var) = @_;
    	    eval q( &le32_to_cpu($var));
	}' unless defined(&NTOH__u32);
	eval 'sub NTOH__u64 {
	    local($var) = @_;
    	    eval q( &le64_to_cpu($var));
	}' unless defined(&NTOH__u64);
	eval 'sub HTON__u32 {
	    local($var) = @_;
    	    eval q( &cpu_to_le32($var));
	}' unless defined(&HTON__u32);
	eval 'sub HTON__u64 {
	    local($var) = @_;
    	    eval q( &cpu_to_le64($var));
	}' unless defined(&HTON__u64);
    } else {
	require 'glib.ph';
	eval 'sub NTOH__u32 {
	    local($var) = @_;
    	    eval q( &GUINT32_FROM_LE($var));
	}' unless defined(&NTOH__u32);
	eval 'sub NTOH__u64 {
	    local($var) = @_;
    	    eval q( &GUINT64_FROM_LE($var));
	}' unless defined(&NTOH__u64);
	eval 'sub HTON__u32 {
	    local($var) = @_;
    	    eval q( &GUINT32_TO_LE($var));
	}' unless defined(&HTON__u32);
	eval 'sub HTON__u64 {
	    local($var) = @_;
    	    eval q( &GUINT64_TO_LE($var));
	}' unless defined(&HTON__u64);
    }
    eval 'sub UNLOGV {
        local($var,$type,$ptr,$end) = @_;
	    eval q( &do { $var = *$ptr; $ptr += $sizeof{$type};  &if ($ptr > $end )  &return - &EFAULT; }  &while (0));
    }' unless defined(&UNLOGV);
    eval 'sub LUNLOGV {
        local($var,$type,$ptr,$end) = @_;
	    eval q( &do { $var =  &NTOH$type(*$ptr); $ptr += $sizeof{$type};  &if ($ptr > $end )  &return - &EFAULT; }  &while (0));
    }' unless defined(&LUNLOGV);
    eval 'sub LOGV {
        local($var,$type,$ptr) = @_;
	    eval q( &do { *($ptr) = $var; $ptr += $sizeof{$type}; }  &while (0));
    }' unless defined(&LOGV);
    eval 'sub LLOGV {
        local($var,$type,$ptr) = @_;
	    eval q( &do { *($ptr) =  &HTON$type($var); $ptr += $sizeof{$type}; }  &while (0));
    }' unless defined(&LLOGV);
    eval 'sub UNLOGP {
        local($var,$type,$ptr,$end) = @_;
	    eval q( &do { $var = $ptr; $ptr += $sizeof{$type};  &if ($ptr > $end )  &return - &EFAULT; }  &while (0));
    }' unless defined(&UNLOGP);
    eval 'sub LOGP {
        local($var,$type,$ptr) = @_;
	    eval q( &do {  &memcpy($ptr, $var, $sizeof{$type}); $ptr += $sizeof{$type}; }  &while (0));
    }' unless defined(&LOGP);
    eval 'sub UNLOGL {
        local($var,$type,$len,$ptr,$end) = @_;
	    eval q( &do {  &if ($len == 0) $var = 0;  &else { $var = $ptr; $ptr +=  &size_round($len * $sizeof{$type}); }  &if ($ptr > $end )  &return - &EFAULT; }  &while (0));
    }' unless defined(&UNLOGL);
    eval 'sub UNLOGL0 {
        local($var,$type,$len,$ptr,$end) = @_;
	    eval q( &do {  &UNLOGL($var,$type,$len+1,$ptr,$end);  &if ( *($ptr -  &size_round($len+1) + $len) != ord(\'\\\\0\'))  &return - &EFAULT; }  &while (0));
    }' unless defined(&UNLOGL0);
    eval 'sub LOGL {
        local($var,$len,$ptr) = @_;
	    eval q( &do {  &size_t  &__fill =  &size_round;  &if ( &__fill > 0)  &memset($ptr, 0,  &__fill);  &memcpy($ptr, $var, $len); $ptr +=  &__fill; }  &while (0));
    }' unless defined(&LOGL);
    eval 'sub LOGL0 {
        local($var,$len,$ptr) = @_;
	    eval q( &do {  &if (!$len)  &break;  &memcpy($ptr, $var, $len); *(($ptr) + $len) = 0; $ptr +=  &size_round($len + 1); }  &while (0));
    }' unless defined(&LOGL0);
}
1;
